/* palace.h - Palace DCI main header file
 *
 * $Id: palace.h, v1.0 2002/06/07 18:25:16 nitroglycerine Exp $
 * 
 */

#ifndef _PALACE_H_
#define _PALACE_H_

/* Headers used throughout Palace */
#if HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <sys/io.h>

#include <glib.h>
#include <gtk/gtk.h>
#include <xmms/plugin.h>
#include <xmms/configfile.h>
#include <xmms/xmmsctrl.h>


/* Definitions */
#define NUM_BANDS            8
#define WIDTH 275
#define HEIGHT 116

typedef struct {
	int n_flashes;
	int manual_flash;
	double mean_time_between_flashes;
	struct timeval thistime;
	struct timeval lasttime;
	char *title;
} palace_state_t;


/* Variables */
extern VisPlugin palace_plugin_info;
extern palace_state_t palace_state;


/* Useful debugging macros */
#ifdef DEBUG
#define ENTER_FUNCTION()	printf("Entering function %s at line %i of file %s.\n", __FUNCTION__, __LINE__, __FILE__)
#define LEAVE_FUNCTION()	printf("Leaving function %s at line %i of file %s.\n", __FUNCTION__, __LINE__, __FILE__)
#define MADE_IT_HERE()		printf("Made it to line %i in file %s, function %s.\n", __LINE__, __FILE__, __FUNCTION__)
#define debug_printf(a...)	fprintf(stderr, a)
#else /* DEBUG */
#define ENTER_FUNCTION()
#define LEAVE_FUNCTION()
#define MADE_IT_HERE()
#define debug_printf(a...)
#endif /* DEBUG */


/* Headers from Palace components */
#include "palace-control.h"
#include "palace-config.h"
#include "palace-gtk-util.h"
#include "palace-confdialog.h"

#endif /* _PALACE_H_ */

